diff --git a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
index 458320918..5f9b17c1e 100644
--- a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
@@ -17,6 +17,7 @@ import net.minecraft.core.net.ChatEmotes;
 import net.minecraft.core.net.ICommandListener;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.world.World;
 import net.minecraft.server.net.command.ServerCommandSource;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.*;
@@ -63,7 +64,6 @@ public class ServerPacketHandler extends PacketHandler
 
     public void handlePackets()
     {
-        field_22003_h = false;
         netManager.processReadPackets();
         if (field_15_f - field_22004_g > 20)
         {
@@ -71,6 +71,10 @@ public class ServerPacketHandler extends PacketHandler
         }
     }
 
+    public boolean canInteract() {
+        return playerEntity.getGamemode().canInteract() && playerEntity.isAlive();
+    }
+
     public void kickPlayer(String s)
     {
         playerEntity.func_30002_A();
@@ -110,174 +114,172 @@ public class ServerPacketHandler extends PacketHandler
         if (!playerEntity.isAlive()) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
 
-        field_22003_h = true;
         if (!hasMoved)
         {
             double d = packet.y - lastPosY;
-            if (packet.x == lastPosX && d * d < 0.01D && packet.z == lastPosZ)
+            double dx = packet.x - lastPosX;
+            double dy = packet.y - lastPosY;
+            double dz = packet.z - lastPosZ;
+            dx *= dx;
+            dy *= dy;
+            dz *= dz;
+            if (dx * dx < 0.01D && dy * dy < 0.01D && dz * dz < 0.01D)
             {
                 hasMoved = true;
             }
         }
-        if (hasMoved)
+        if (!hasMoved) return;
+        // Set rotation
+        float yRot = playerEntity.yRot;
+        float xRot = playerEntity.xRot;
+        if (packet.hasRotation)
+        {
+            yRot = MathHelper.normalizeRotation(packet.yaw);
+            xRot = MathHelper.normalizeRotation(packet.pitch);
+        }
+
+        // No moving when sleeping or sitting in a static vehicle
+        boolean sleeping = playerEntity.isPlayerSleeping();
+        boolean sitting = playerEntity.vehicle != null && !(playerEntity.vehicle instanceof Entity);
+        if (sleeping || sitting)
+        {
+            if (sitting) playerEntity.vehicle.positionRider();
+            playerEntity.onUpdateEntity();
+            // onUpdateEntity updates the lastPos*
+            playerEntity.absMoveTo(lastPosX, lastPosY, lastPosZ, playerEntity.yRot, playerEntity.xRot);
+            worldserver.updateEntity(playerEntity);
+            return;
+        }
+
+        // In a entity vehicle
+        if (playerEntity.vehicle instanceof Entity)
         {
-            if (playerEntity.vehicle != null)
+            playerEntity.vehicle.positionRider();
+            double xd = 0.0D;
+            double zd = 0.0D;
+            if (packet.hasPosition && packet.y == -999D)
             {
-                float f = playerEntity.yRot;
-                float f1 = playerEntity.xRot;
-                playerEntity.vehicle.positionRider();
-                double d2 = playerEntity.x;
-                double d4 = playerEntity.y;
-                double d6 = playerEntity.z;
-                double d8 = 0.0D;
-                double d9 = 0.0D;
-                if (packet.hasRotation)
-                {
-                    f = packet.yaw;
-                    f1 = packet.pitch;
-                }
-                if (packet.hasPosition && packet.y == -999D && packet.yView == -999D)
-                {
-                    d8 = packet.x;
-                    d9 = packet.z;
-                }
-                playerEntity.onGround = packet.onGround;
-                playerEntity.onUpdateEntity();
-                playerEntity.move(d8, 0.0D, d9);
-                playerEntity.absMoveTo(d2, d4, d6, f, f1);
-                playerEntity.xd = d8;
-                playerEntity.zd = d9;
-                if (playerEntity.vehicle != null && playerEntity.vehicle instanceof Entity)
-                {
-                    worldserver.func_12017_b((Entity) playerEntity.vehicle, true);
-                }
-                if (playerEntity.vehicle != null)
-                {
-                    playerEntity.vehicle.positionRider();
-                }
-                mcServer.playerList.func_613_b(playerEntity);
-                lastPosX = playerEntity.x;
-                lastPosY = playerEntity.y;
-                lastPosZ = playerEntity.z;
-                worldserver.updateEntity(playerEntity);
-                return;
+                xd = packet.x;
+                zd = packet.z;
             }
-            if (playerEntity.isPlayerSleeping())
+            playerEntity.onGround = packet.onGround;
+            playerEntity.onUpdateEntity();
+            playerEntity.move(xd, 0.0D, zd);
+            playerEntity.absMoveTo(playerEntity.x, playerEntity.y, playerEntity.z, yRot, xRot);
+            playerEntity.xd = xd;
+            playerEntity.zd = zd;
+            // TODO: Is this needing? It does allow for fast-tick exploits.
+            //worldserver.func_12017_b((Entity) playerEntity.vehicle, true);
+            playerEntity.vehicle.positionRider();
+            return;
+        }
+
+        // Not sitting, sleeping, or riding. Move them normally
+        lastPosX = playerEntity.x;
+        lastPosY = playerEntity.y;
+        lastPosZ = playerEntity.z;
+        double newPosX = playerEntity.x;
+        double newPosY = playerEntity.y;
+        double oldPosY = playerEntity.y;
+        double newPosZ = playerEntity.z;
+        if (packet.hasPosition && packet.y == -999D)
+        {
+            packet.hasPosition = false;
+        }
+        if (packet.hasPosition)
+        {
+            newPosX = packet.x;
+            newPosY = packet.y;
+            newPosZ = packet.z;
+            // Lag back the player if they attempt to move to an illegal position
+            if (Math.abs(packet.x) > World.MAX_BLOCK_X || Math.abs(packet.z) > World.MAX_BLOCK_Z || Double.isNaN(packet.x) || Double.isNaN(packet.y) || Double.isNaN(packet.z))
             {
-                playerEntity.onUpdateEntity();
-                playerEntity.absMoveTo(lastPosX, lastPosY, lastPosZ, playerEntity.yRot, playerEntity.xRot);
-                worldserver.updateEntity(playerEntity);
+                //kickPlayer("Illegal position");
+                LOGGER.warn("{} tried to move to an illegal position", playerEntity.username);
+                teleportAndRotate(lastPosX, lastPosY, lastPosZ, yRot, xRot);
                 return;
             }
-            double oldY = playerEntity.y;
-            lastPosX = playerEntity.x;
-            lastPosY = playerEntity.y;
-            lastPosZ = playerEntity.z;
-            double newPosX = playerEntity.x;
-            double newPosY = playerEntity.y;
-            double newPosZ = playerEntity.z;
-            float f2 = playerEntity.yRot;
-            float f3 = playerEntity.xRot;
-            if (packet.hasPosition && packet.y == -999D && packet.yView == -999D)
-            {
-                packet.hasPosition = false;
-            }
-            if (packet.hasPosition)
+        }
+        // TODO: THIS IS VERY BAD! Fix ASAP!
+        playerEntity.onUpdateEntity();
+        playerEntity.ySlideOffset = 0.0F;
+        playerEntity.absMoveTo(lastPosX, lastPosY, lastPosZ, yRot, xRot);
+        if (!hasMoved)
+        {
+            return;
+        }
+        double dx = newPosX - playerEntity.x;
+        double dy = newPosY - playerEntity.y;
+        double dz = newPosZ - playerEntity.z;
+        double velSquared = dx * dx + dy * dy + dz * dz;
+        // Lag back the player if they move too quickly
+        if (velSquared > 100D)
+        {
+            // This doesn't mean they are necessarily hacking, it's easy to do by hitting the vanilla speed limit
+            LOGGER.warn("{} moved too quickly!", playerEntity.username);
+            teleportAndRotate(lastPosX, lastPosY, lastPosZ, yRot, xRot);
+            //kickPlayer("You moved too quickly :( (Hacking?)");
+            return;
+        }
+        // Time to trying and move like they did
+        float bb_expand = 0.0625F;
+        boolean insideBlockOld = worldserver.getCubes(playerEntity, playerEntity.bb.copy().getInsetBoundingBox(bb_expand, bb_expand, bb_expand)).isEmpty();
+        playerEntity.move(dx, dy, dz);
+        // Get the difference in intended move and actual move
+        dx = newPosX - playerEntity.x;
+        double ndy = newPosY - playerEntity.y;
+        dz = newPosZ - playerEntity.z;
+        velSquared = dx * dx + ndy * ndy + dz * dz;
+        boolean movedWrong = false;
+        // TODO: Check if the player is flying instead of if they can fly, this information should be synced as in BTA flying is more than just no gravity
+        if (!playerEntity.getGamemode().canPlayerFly() && velSquared > 0.0625D && !playerEntity.isPlayerSleeping())
+        {
+            movedWrong = true;
+            LOGGER.warn("{} moved wrongly!", playerEntity.username);
+            LOGGER.warn("Got position {}, {}, {}", newPosX, newPosY, newPosZ);
+            LOGGER.warn("Expected {}, {}, {}", playerEntity.x, playerEntity.y, playerEntity.z);
+        }
+        playerEntity.absMoveTo(newPosX, newPosY, newPosZ, yRot, xRot);
+        boolean insideBlockNew = worldserver.getCubes(playerEntity, playerEntity.bb.copy().getInsetBoundingBox(bb_expand, bb_expand, bb_expand)).isEmpty();
+        if (!playerEntity.getGamemode().canPlayerFly() && insideBlockOld && (movedWrong || !insideBlockNew) && !playerEntity.isPlayerSleeping())
+        {
+            // If the player:
+            // - Is inside a block and wasn't on the last tick
+            // - Moved wrongly
+            // - And is not sleeping or flying
+            // Bounce them back
+            teleportAndRotate(lastPosX, lastPosY, lastPosZ, yRot, xRot);
+            return;
+        }
+
+        // Falling and ground collision
+        AABB aabb = playerEntity.bb.copy().grow(bb_expand, bb_expand, bb_expand).expand(0.0D, -0.55D, 0.0D);
+        if (!playerEntity.getGamemode().canPlayerFly() && !mcServer.allowFlight && !worldserver.getIsAnySolidGround(aabb))
+        {
+            // Don't tick fly counter if they are falling
+            if (dy > -0.03125D)
             {
-                newPosX = packet.x;
-                newPosY = packet.y;
-                newPosZ = packet.z;
-                // I don't see why the server really needs to care about stance
-//                double d10 = packet.stance - packet.yPosition;
-//                if (!playerEntity.isPlayerSleeping() && (d10 > 1.65D || d10 < 0.1D))
-//                {
-//                    kickPlayer("Illegal stance");
-//                    return;
-//                }
-                // Lag back the player if they attempt to move to an illegal position
-                if (java.lang.Math.abs(packet.x) > 32000000D || java.lang.Math.abs(packet.z) > 32000000D)
-                {
-//                    kickPlayer("Illegal position");
-                    LOGGER.warn("{} tried to move to an illegal position", playerEntity.username);
-                    teleportAndRotate(lastPosX, lastPosY, lastPosZ, f2, f3);
+                playerInAirTime++;
+                if (playerInAirTime > 100) {
+                    LOGGER.warn(playerEntity.username + " was kicked for floating too long!");
+                    kickPlayer("Flying is not enabled on this server");
                     return;
                 }
-            }
-            if (packet.hasRotation)
-            {
-                f2 = packet.yaw;
-                f3 = packet.pitch;
-            }
-            playerEntity.onUpdateEntity();
-            playerEntity.ySlideOffset = 0.0F;
-            playerEntity.absMoveTo(lastPosX, lastPosY, lastPosZ, f2, f3);
-            if (!hasMoved)
-            {
-                return;
-            }
-            double dx = newPosX - playerEntity.x;
-            double dy = newPosY - playerEntity.y;
-            double dz = newPosZ - playerEntity.z;
-            double velSquared = dx * dx + dy * dy + dz * dz;
-            // Lag back the player if they move too quickly
-            if (velSquared > 100D)
-            {
-                LOGGER.warn("{} moved too quickly!", playerEntity.username);
-                teleportAndRotate(lastPosX, lastPosY, lastPosZ, f2, f3);
-//                kickPlayer("You moved too quickly :( (Hacking?)");
-                return;
-            }
-            float f4 = 0.0625F;
-            boolean flag = worldserver.getCubes(playerEntity, playerEntity.bb.copy().getInsetBoundingBox(f4, f4, f4)).size() == 0;
-            playerEntity.move(dx, dy, dz);
-            dx = newPosX - playerEntity.x;
-            dy = newPosY - playerEntity.y;
-            if (dy > -0.5D || dy < 0.5D)
-            {
-                dy = 0.0D;
-            }
-            dz = newPosZ - playerEntity.z;
-            velSquared = dx * dx + dy * dy + dz * dz;
-            boolean flag1 = false;
-            if (!playerEntity.getGamemode().canPlayerFly() && velSquared > 0.0625D && !playerEntity.isPlayerSleeping() && playerEntity.pushTime < 0.05)
-            {
-                flag1 = true;
-                LOGGER.warn("{} moved wrongly!", playerEntity.username);
-                LOGGER.warn("Got position {}, {}, {}", newPosX, newPosY, newPosZ);
-                LOGGER.warn("Expected {}, {}, {}", playerEntity.x, playerEntity.y, playerEntity.z);
-            }
-            playerEntity.absMoveTo(newPosX, newPosY, newPosZ, f2, f3);
-            boolean flag2 = worldserver.getCubes(playerEntity, playerEntity.bb.copy().getInsetBoundingBox(f4, f4, f4)).isEmpty();
-            if (!playerEntity.getGamemode().canPlayerFly() && flag && (flag1 || !flag2) && !playerEntity.isPlayerSleeping() && playerEntity.pushTime < 0.05)
-            {
-                teleportAndRotate(lastPosX, lastPosY, lastPosZ, f2, f3);
-                return;
-            }
-            AABB aabb = playerEntity.bb.copy().grow(f4, f4, f4).expand(0.0D, -0.55D, 0.0D);
-            if (!playerEntity.getGamemode().canPlayerFly() && !mcServer.allowFlight && !worldserver.getIsAnySolidGround(aabb) && playerEntity.pushTime < 0.05)
-            {
-                if (dy > -0.03125D)
+                // I'm not sure what this is, but it seems like it wouldn't work.
+                /*} else if (playerInAirTime > 80)
                 {
-                    playerInAirTime++;
-                    if (playerInAirTime > 100) {
-                        LOGGER.warn(playerEntity.username + " was kicked for floating too long!");
-                        kickPlayer("Flying is not enabled on this server");
-                        return;
-                    } else if (playerInAirTime > 80)
-                    {
-                        teleportAndRotate(lastPosX, lastPosY, lastPosZ, f2, f3);
-                    }
-                }
-            }
-            else
-            {
-                playerInAirTime = 0;
+                    teleportAndRotate(lastPosX, lastPosY, lastPosZ, yRot, xRot);
+                }*/
             }
-            playerEntity.onGround = packet.onGround;
-            mcServer.playerList.func_613_b(playerEntity);
-            playerEntity.handleFalling(playerEntity.y - oldY, packet.onGround);
-
         }
+        else
+        {
+            playerInAirTime = 0;
+        }
+        // TODO: Should we really trust the client to tell the server if they are on the ground?
+        playerEntity.onGround = packet.onGround;
+        mcServer.playerList.onPlayerMoved(playerEntity);
+        playerEntity.handleFalling(playerEntity.y - oldPosY, packet.onGround);
     }
 
 	public void teleport(double x, double y, double z) {
@@ -286,7 +288,7 @@ public class ServerPacketHandler extends PacketHandler
 		lastPosY = y;
 		lastPosZ = z;
 		playerEntity.absMoveTo(x, y, z, playerEntity.yRot, playerEntity.xRot);
-		playerEntity.playerNetServerHandler.sendPacket(new MovePlayerPacket.Pos(x, y + 1.625, y, z, false));
+		playerEntity.playerNetServerHandler.sendPacket(new MovePlayerPacket.Pos(x, y + 1.625, z, false));
 	}
 
 	public void teleportAndRotate(double x, double y, double z, float yaw, float pitch) {
@@ -295,26 +297,26 @@ public class ServerPacketHandler extends PacketHandler
 		lastPosY = y;
 		lastPosZ = z;
 		playerEntity.absMoveTo(x, y, z, yaw, pitch);
-		playerEntity.playerNetServerHandler.sendPacket(new MovePlayerPacket.PosRot(x, y + 1.625, y, z, yaw, pitch, false));
+		playerEntity.playerNetServerHandler.sendPacket(new MovePlayerPacket.PosRot(x, y + 1.625, z, yaw, pitch, false));
 	}
 
     @Override
-    public void handleBlockDig(PlayerActionPacket packet) {
-        final int x = packet.xPosition;
-        final int y = packet.yPosition;
-        final int z = packet.zPosition;
+    public void handleBlockDig(PlayerActionPacket playerActionPacket) {
+        final int x = playerActionPacket.xPosition;
+        final int y = playerActionPacket.yPosition;
+        final int z = playerActionPacket.zPosition;
 
-        if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive() || playerEntity.getHeldObject() != null /*Forbid digging while holding object*/) return;
+        if (!canInteract() || playerEntity.getHeldObject() != null /*Forbid digging while holding object*/) return;
         WorldServer world = mcServer.getDimensionWorld(playerEntity.dimension);
-        if(packet.status == 4) {
+        if(playerActionPacket.action == PlayerActionPacket.ACTION_DROP_ITEM_SINGLE) {
             // Drop single item
             playerEntity.dropCurrentItem(false);
             return;
-        }else if(packet.status == 5) {
+        }else if(playerActionPacket.action == PlayerActionPacket.ACTION_DROP_ITEM_STACK) {
             // Drop full stack
             playerEntity.dropCurrentItem(true);
             return;
-        }else if(packet.status == 6) {
+        }else if(playerActionPacket.action == PlayerActionPacket.ACTION_PICK_BLOCK) {
             // Pick Block
             playerEntity.pickBlock(x, y, z);
             return;
@@ -341,15 +343,15 @@ public class ServerPacketHandler extends PacketHandler
         }
 
         // handles spawn protection
-        if(packet.status == 0) {
+        if(playerActionPacket.action == PlayerActionPacket.ACTION_DIG_START) {
             // Start Mining
-            playerEntity.playerController.startMining(x, y, z, packet.side);
-        } else if(packet.status == 1) {
+            playerEntity.playerController.startMining(x, y, z, playerActionPacket.side);
+        } else if(playerActionPacket.action == PlayerActionPacket.ACTION_DIG_CONTINUED) {
             // Hit Block
-            playerEntity.playerController.hitBlock(x, y, z, packet.side, packet.xHit, packet.yHit);
-        } else if(packet.status == 2) {
+            playerEntity.playerController.hitBlock(x, y, z, playerActionPacket.side, playerActionPacket.xHit, playerActionPacket.yHit);
+        } else if(playerActionPacket.action == PlayerActionPacket.ACTION_DIG_COMPLETE) {
             // Block Destroy
-            if(!playerEntity.playerController.destroyBlock(x, y, z, packet.side)) {
+            if(!playerEntity.playerController.destroyBlock(x, y, z, playerActionPacket.side)) {
                 playerEntity.playerNetServerHandler.sendPacket(new BlockUpdatePacket(x, y, z, world));
             }
         }
@@ -366,7 +368,7 @@ public class ServerPacketHandler extends PacketHandler
     @Override
     public void handlePlace(UseItemPacket packet)
     {
-        if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive()) return;
+        if (!canInteract()) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
         ItemStack itemstack = playerEntity.inventory.getCurrentItem();
         boolean ignoreSpawnProtection = mcServer.spawnProtectionRange <= 0 || worldserver.dimension.id != 0 || mcServer.playerList.isOp(playerEntity.uuid);
@@ -424,9 +426,9 @@ public class ServerPacketHandler extends PacketHandler
     }
 
     @Override
-    public void handleErrorMessage(String s, Object[] aobj)
+    public void handleErrorMessage(String message, Object[] objects)
     {
-        LOGGER.info(playerEntity.username + " lost connection: " + s);
+        LOGGER.info(playerEntity.username + " lost connection: " + message);
         mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(playerEntity.getDisplayName() + TextFormatting.YELLOW + " left the game."));
         mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(playerEntity.username, playerEntity.nickname, playerEntity.uuid, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator()));
         mcServer.playerList.playerLoggedOut(playerEntity);
@@ -452,20 +454,18 @@ public class ServerPacketHandler extends PacketHandler
     }
 
     @Override
-    public void handleBlockItemSwitch(SetCarriedItemPacket packet)
+    public void handleBlockItemSwitch(SetCarriedItemPacket setCarriedItemPacket)
     {
-        if (packet.id < 0 || packet.id > Inventory.func_25054_e())
+        if (setCarriedItemPacket.id < 0 || setCarriedItemPacket.id > Inventory.playerMainInventorySize())
         {
             LOGGER.warn("{} tried to set an invalid carried item", playerEntity.username);
-            return;
         }
         else
         {
-            playerEntity.inventory.setCurrentItemIndex(packet.id, false);
-            if (packet.id != playerEntity.inventory.getCurrentItemIndex()) { // If client tried to set current item while locked then send a packet back attempting to resync them
-                sendPacket(new SetCarriedItemPacket(packet.id));
+            playerEntity.inventory.setCurrentItemIndex(setCarriedItemPacket.id, false);
+            if (setCarriedItemPacket.id != playerEntity.inventory.getCurrentItemIndex()) { // If client tried to set current item while locked then send a packet back attempting to resync them
+                sendPacket(new SetCarriedItemPacket(setCarriedItemPacket.id));
             }
-            return;
         }
     }
 
@@ -528,18 +528,18 @@ public class ServerPacketHandler extends PacketHandler
     }
 
     @Override
-    public void handleEntityAction(PlayerCommandPacket packet)
+    public void handlePlayerState(UpdatePlayerStatePacket updatePlayerStatePacket)
     {
         if (!playerEntity.isAlive()) return;
-        if (packet.state == 1)
+        if (updatePlayerStatePacket.state == UpdatePlayerStatePacket.STATE_SNEAK)
         {
             playerEntity.setSneaking(true);
         }
-        else if (packet.state == 2)
+        else if (updatePlayerStatePacket.state == UpdatePlayerStatePacket.STATE_UN_SNEAK)
         {
             playerEntity.setSneaking(false);
         }
-        else if (packet.state == 3)
+        else if (updatePlayerStatePacket.state == UpdatePlayerStatePacket.STATE_LEAVE_BED)
         {
             playerEntity.wakeUpPlayer(false, true);
             hasMoved = false;
@@ -548,8 +548,8 @@ public class ServerPacketHandler extends PacketHandler
     @Override
     public void handleBoatControl(BoatControlPacket boatControlPacket)
     {
-        if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive()) return;
-        if (playerEntity.vehicle != null && playerEntity.vehicle instanceof BoatEntity){
+        if (!canInteract()) return;
+        if (playerEntity.vehicle != null && playerEntity.vehicle instanceof BoatEntity && !Double.isNaN(boatControlPacket.targetXD) && !Double.isNaN(boatControlPacket.targetZD)) {
             BoatEntity boat = (BoatEntity) playerEntity.vehicle;
             boat.handleControlDirect(boatControlPacket.targetXD, boatControlPacket.targetZD, boatControlPacket.targetYRot);
             boatControlPacket.entityId = boat.id;
@@ -581,11 +581,11 @@ public class ServerPacketHandler extends PacketHandler
     }
 
     @Override
-    public void handleUseEntity(InteractPacket packet)
+    public void handleUseEntity(InteractPacket interactPacket)
     {
         if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive() || playerEntity.getHeldObject() != null /*TODO consider adding entity interactions while holding object*/) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
-        Entity targetEntity = worldserver.getEntityFromId(packet.targetEntityID);
+        Entity targetEntity = worldserver.getEntityFromId(interactPacket.targetEntityID);
         if (targetEntity != null && playerEntity.distanceToSqr(targetEntity) < 36D)
         {
             boolean canAttack = playerEntity.canEntityBeSeen(targetEntity);
@@ -614,11 +614,11 @@ public class ServerPacketHandler extends PacketHandler
             }
             if (canAttack)
             {
-                if (packet.action == InteractPacket.ACTION_INTERACT)
+                if (interactPacket.action == InteractPacket.ACTION_INTERACT)
                 {
                     playerEntity.useCurrentItemOnEntity(targetEntity);
                 }
-                else if (packet.action == InteractPacket.ACTION_ATTACK)
+                else if (interactPacket.action == InteractPacket.ACTION_ATTACK)
                 {
                     playerEntity.attackTargetEntityWithCurrentItem(targetEntity);
                 }
@@ -641,20 +641,20 @@ public class ServerPacketHandler extends PacketHandler
     }
 
     @Override
-    public void handleCloseWindow(ContainerClosePacket packet)
+    public void handleCloseWindow(ContainerClosePacket containerClosePacket)
     {
         playerEntity.closeCraftingGui();
     }
 
     @Override
-    public void handleWindowClick(ContainerClickPacket packet)
+    public void handleWindowClick(ContainerClickPacket containerClickPacket)
     {
-        if (playerEntity.craftingInventory.containerId == packet.window_Id && playerEntity.craftingInventory.isSynched(playerEntity))
+        if (playerEntity.craftingInventory.containerId == containerClickPacket.window_Id && playerEntity.craftingInventory.isSynched(playerEntity))
         {
-            ItemStack itemstack = playerEntity.craftingInventory.clicked(packet.action, packet.args, playerEntity);
-            if (ItemStack.areItemStacksEqual(packet.itemStack, itemstack))
+            ItemStack itemstack = playerEntity.craftingInventory.clicked(containerClickPacket.action, containerClickPacket.args, playerEntity);
+            if (ItemStack.areItemStacksEqual(containerClickPacket.itemStack, itemstack))
             {
-                playerEntity.playerNetServerHandler.sendPacket(new ContainerAckPacket(packet.window_Id, packet.actionId, true));
+                playerEntity.playerNetServerHandler.sendPacket(new ContainerAckPacket(containerClickPacket.window_Id, containerClickPacket.actionId, true));
                 playerEntity.isChangingQuantityOnly = true;
                 playerEntity.craftingInventory.broadcastChanges();
                 playerEntity.updateHeldItem();
@@ -662,8 +662,8 @@ public class ServerPacketHandler extends PacketHandler
             }
             else
             {
-                guiIdMap.put(playerEntity.craftingInventory.containerId, packet.actionId);
-                playerEntity.playerNetServerHandler.sendPacket(new ContainerAckPacket(packet.window_Id, packet.actionId, false));
+                guiIdMap.put(playerEntity.craftingInventory.containerId, containerClickPacket.actionId);
+                playerEntity.playerNetServerHandler.sendPacket(new ContainerAckPacket(containerClickPacket.window_Id, containerClickPacket.actionId, false));
                 playerEntity.craftingInventory.setSynched(playerEntity, false);
                 ArrayList<ItemStack> arraylist = new ArrayList<>();
                 for (int i = 0; i < playerEntity.craftingInventory.slots.size(); i++)
@@ -687,13 +687,13 @@ public class ServerPacketHandler extends PacketHandler
     }
 
     @Override
-    public void handleUpdateSign(SignUpdatePacket packet)
+    public void handleUpdateSign(SignUpdatePacket signUpdatePacket)
     {
         if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive()) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
-        if (worldserver.isBlockLoaded(packet.xPosition, packet.yPosition, packet.zPosition))
+        if (worldserver.isBlockLoaded(signUpdatePacket.xPosition, signUpdatePacket.yPosition, signUpdatePacket.zPosition))
         {
-            BlockEntity blockEntity = worldserver.getBlockEntity(packet.xPosition, packet.yPosition, packet.zPosition);
+            BlockEntity blockEntity = worldserver.getBlockEntity(signUpdatePacket.xPosition, signUpdatePacket.yPosition, signUpdatePacket.zPosition);
             if (blockEntity instanceof SignBlockEntity)
             {
                 SignBlockEntity sign = (SignBlockEntity) blockEntity;
@@ -706,16 +706,16 @@ public class ServerPacketHandler extends PacketHandler
             for (int i = 0; i < 4; i++)
             {
                 boolean isLineValid = true;
-                if (packet.signLines[i].length() > 15)
+                if (signUpdatePacket.signLines[i].length() > 15)
                 {
                     isLineValid = false;
                 }
                 else
                 {
-                    packet.signLines[i] = packet.signLines[i].replaceAll("§", "$");
-                    for (int l = 0; l < packet.signLines[i].length(); l++)
+                    signUpdatePacket.signLines[i] = signUpdatePacket.signLines[i].replaceAll("§", "$");
+                    for (int l = 0; l < signUpdatePacket.signLines[i].length(); l++)
                     {
-                        if (ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(packet.signLines[i].charAt(l)) < 0)
+                        if (ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(signUpdatePacket.signLines[i].charAt(l)) < 0)
                         {
                             isLineValid = false;
                             break;
